#ifndef CONSOLEBUFFER_H__
#define CONSOLEBUFFER_H__

/********************************************************************
	created:	2009/10/09
	filename: 	ConsoleBuffer.h
	author:		Daniel Wellman
	
	purpose:	Represents a Win32 console buffer that can be written to directly

	License: This software may be reproduced and distributed free of charge as
	as long as credit is given to the author. The author assumes no
	responsibility. The software is provided as is.
*********************************************************************/
#include <string>
#include <windows.h>
#include "NonCopyable.h"

namespace LuaAutomata
{
	enum Color;
	class ConsoleBuffer : public NonCopyable
	{
	public:
		ConsoleBuffer(unsigned width, unsigned height);
		~ConsoleBuffer();
		void SetActive();
		void WriteChar(char charToWrite, unsigned x, unsigned y, Color foreground, Color background);
		void Clear();
	private:

		CHAR_INFO* m_charBuffer;
		HANDLE m_screenBuffer;
		const unsigned m_width;
		const unsigned m_height;
	};
}
#endif // CONSOLEBUFFER_H__
