#ifndef FRAMELIMITER_H__
#define FRAMELIMITER_H__

/********************************************************************
	created:	2009/10/09
	filename: 	FrameLimiter.h
	author:		Daniel Wellman
	
	purpose:	Limits the number of frames drawn per second

	License: This software may be reproduced and distributed free of charge as
	as long as credit is given to the author. The author assumes no
	responsibility. The software is provided as is.
*********************************************************************/

#include <Windows.h>

namespace LuaAutomata
{
	class FrameLimiter
	{
	public:
		explicit FrameLimiter(double fps = 60.0);
		bool IsTimeUp() const;
		double Tick();
		void ResetTime();

		void SetMaxFps(double fps);
	private:
		double m_fps;

		LONGLONG m_frequency;
		LONGLONG m_timeBetweenFrames;
		double m_secondsPerFrequency;
		LONGLONG m_nextTime, m_currentTime, m_lastTime;
	};
}
#endif // FRAMELIMITER_H__