#ifndef LUAGRAPHICS_H__
#define LUAGRAPHICS_H__

/********************************************************************
	created:	2009/10/09
	filename: 	LuaManager.h
	author:		Daniel Wellman
	
	purpose:	Creates a lua state and binds update and drawing to a Console instance

	License: This software may be reproduced and distributed free of charge as
	as long as credit is given to the author. The author assumes no
	responsibility. The software is provided as is.
*********************************************************************/
#include <string>
#include "NonCopyable.h"

struct lua_State;
namespace LuaAutomata
{
	class Console;

	class LuaGame : public NonCopyable
	{
	public:
		LuaGame(Console& console, unsigned width, unsigned height);
		~LuaGame();
		void Update(float dt);
		void Draw();
		bool IsExiting() const { return  m_exiting; };
	private:
		lua_State* const L;
		bool m_exiting;

		void Error(const char* const error);
	};
}
#endif // LUAGRAPHICS_H__