#ifndef NONCOPYABLE_H__
#define NONCOPYABLE_H__
/********************************************************************
	created:	2009/10/09
	filename: 	NonCopyable.h
	author:		Daniel Wellman
	
	purpose:	Classes that inherit from this class will not be copyable

	License: This software may be reproduced and distributed free of charge as
	as long as credit is given to the author. The author assumes no
	responsibility. The software is provided as is.
*********************************************************************/

namespace LuaAutomata
{
	class NonCopyable
	{
	protected:
		NonCopyable(){}
		~NonCopyable(){}
	private:
		//Not copyable
		NonCopyable operator=(NonCopyable&);
		NonCopyable(NonCopyable&);
	};
}
#endif // NONCOPYABLE_H__